/* 

   March 2009, Ferragina Paolo (ferragina@di.unipi.it)
   Copyright @ Paolo Ferragina.

*/


#define CHECK_ERR(err, msg) { \
    if (err != Z_OK) { \
        fprintf(stderr, "%s error: %d\n", msg, err); \
        exit(1); \
    } \
}


void printPrefix(char *s, int n)
{	
  int i;

  for (i = 0; i < n; i++) 
    printf("%c",s[i]);

}

int getLine(char *s, int lim)
{
  int c,i;
  
  i=0;
  c = 'x';
  while((--lim>0) && ((c=getchar())!= EOF) && (c != '\n'))    
    s[i++]= (char) c;

  if (c == '\n')
    s[i++]= (char) c;

  if(lim == 0){
    fprintf(stderr,"\nRow is too long... sorry!\n"); 
    exit(1);  }

  s[i] = '\0'; /* for printing purposes */
  return i;
}




// In millisecs
double getTime(void)
{

  double usertime, systime;
  struct rusage usage;

  getrusage(RUSAGE_SELF, &usage);

  usertime = (double) usage.ru_utime.tv_sec * 1000 +
    (double) usage.ru_utime.tv_usec / 1000.0;
  systime = (double) usage.ru_stime.tv_sec * 1000 +
    (double) usage.ru_stime.tv_usec / 1000.0;
  return (usertime + systime);

}


int getInt(unsigned char *b)
{
  int c=0;
  
  c += b[0];
  c <<= 8;
  c += b[1];
  c <<= 8;
  c += b[2];
  c <<= 8;
  c += b[3];
  c <<= 8;

  return(c);
}


